﻿package {

	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.events.FocusEvent;
	import flash.events.IOErrorEvent;
	import flash.ui.Keyboard;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.utils.ByteArray;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.Capabilities;
	import mx.graphics.codec.JPEGEncoder;
	
	// AIR imports
	import flash.desktop.DragManager;
	import flash.desktop.ClipboardFormats;
	import flash.desktop.Clipboard;
	import flash.events.NativeDragEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileStream;
	import flash.filesystem.FileMode;
	import flash.display.NativeWindowResize;
	import flash.display.NativeWindow;
	import flash.display.Screen;
	import flash.system.Shell;

	public class Main extends Sprite {
	// constants:
	// private properties:
		private var loader:Loader;
		private var bmp:Bitmap;
		private var hPad:Number;
		private var vPad:Number;
		private var imageFileExtensions:Object = {jpg:1,jpeg:1,png:1,gif:1};
		
		private var fileName:String;
	// public properties:
		
	// constructor:
		public function Main() {
			stage.addEventListener(Event.RESIZE,handleResize);
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			vPad = background.height-imageBackground.height;
			hPad = background.width-imageBackground.width;
			
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,handleLoadError);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE,handleLoadComplete);
			
			bmp = new Bitmap();
			addChildAt(bmp,getChildIndex(dragHighlight));
			bmp.x = bmp.y = 5;
			bmp.visible = false;
			
			updateView(background.width,background.height);
			resetHighlight();
			enableInterface(false);
			
			
			setupForAIR();
		}
		
	// public getter/setters:
	// public methods:
	// private methods:
		
		private function enableInterface(value:Boolean=true):void {
			leftControls.saveBtn.mouseEnabled = value;
			leftControls.saveBtn.alpha = (value) ? 1 : 0.5;
		}
		
		private function handleResize(evt:Event):void {
			updateView(stage.stageWidth, stage.stageHeight);
		}
		
		private function updateView(w:Number, h:Number):void {
			background.width = w;
			background.height = h;
			rightControls.y = leftControls.y = h-5;
			rightControls.x = w-5;
			imageBackground.width = w-hPad;
			imageBackground.height = h-vPad;
			dragTxt.x = w>>1;
			dragTxt.y = (h-20)>>1;
			rightControls.widthFld.text = imageBackground.width;
			rightControls.heightFld.text = imageBackground.height;
			dragHighlight.width = imageBackground.width-2;
			dragHighlight.height = imageBackground.height-2;
			updateImage(w-hPad,h-vPad);
		}
		
		private function updateImage(w:Number,h:Number):void {
			bmp.width = w;
			bmp.height = h;
			bmp.x = ((imageBackground.width-w)>>1)+5;
			bmp.y = ((imageBackground.height-h)>>1)+5;
		}
		
		private function setInnerSize(w:Number, h:Number):void {
			updateAIRWindow(w+hPad, h+vPad);
		}
		
		private function resetHighlight():void {
			dragHighlight.visible = !bmp.visible;
			dragHighlight.alpha = 0.5;
		}
		
		private function handleLoadComplete(evt:Event):void {
			var bmpd:BitmapData = new BitmapData(loader.content.width,loader.content.height,false,0);
			bmpd.draw(loader.content);
			loader.unload();
			setBitmapData(bmpd);
		}
		
		private function handleLoadError(evt:Event):void {
			resetHighlight();
		}
		
		private function setBitmapData(bmpd:BitmapData):void {
			bmp.bitmapData = bmpd;
			bmp.smoothing = true;
			bmp.visible = true;
			dragTxt.visible = false;
			dragHighlight.visible = false;
			enableInterface(true);
			setInnerSize(bmpd.width,bmpd.height);
		}
		
		// AIR specific functionality:
		private function setupForAIR():void {
			//
			setupAIRControls();
			//
			
			var screenBounds:Rectangle = Screen.mainScreen.visibleBounds;
			stage.nativeWindow.minSize = new Point(250+hPad,100+vPad);
			stage.nativeWindow.maxSize = new Point(screenBounds.width-10,screenBounds.height-10);
			//
			setupAIRDragDrop();
		}
		
		
		// set up controls:
		private function setupAIRControls():void {
			leftControls.closeBtn.addEventListener(MouseEvent.CLICK, handleClose,false,0,true);
			leftControls.saveBtn.addEventListener(MouseEvent.CLICK, handleSave,false,0,true);
			background.addEventListener(MouseEvent.MOUSE_DOWN, handleDragWindow,false,0,true);
			background.doubleClickEnabled = true;
			background.addEventListener(MouseEvent.DOUBLE_CLICK, handleMinimize,false,0,true);
			rightControls.resizeBtn.addEventListener(MouseEvent.MOUSE_DOWN,handleDragResize,false,0,true);
		}
		
		private function handleClose(evt:MouseEvent):void {
			stage.nativeWindow.close();
		}
		
		private function handleDragWindow(evt:MouseEvent):void {
			stage.nativeWindow.startMove();
		}
		
		private function handleMinimize(evt:MouseEvent):void {
			stage.nativeWindow.minimize();
		}
		
		private function handleDragResize(evt:MouseEvent):void {
			stage.nativeWindow.startResize(NativeWindowResize.BOTTOM_RIGHT);
		}
		
		
		// control window resize (also min / max in setupForAIR):
		private function updateAIRWindow(w:Number,h:Number):void {
			var win:NativeWindow = stage.nativeWindow;
			var screenBounds:Rectangle = Screen.mainScreen.visibleBounds;
			
			win.height = h;
			win.width = w;
			
			win.x = Math.max(screenBounds.x+5,Math.min(win.x, screenBounds.width-win.width-5));
			win.y = Math.max(screenBounds.y+5,Math.min(win.y, screenBounds.height-win.height-5));
		}
		
		
		// AIR drag / drop:
		private function setupAIRDragDrop():void {
			// prevent overlays from intercepting drag events:
			dragHighlight.mouseEnabled = loader.mouseEnabled = dragTxt.mouseEnabled = false;
			
			imageBackground.addEventListener(NativeDragEvent.NATIVE_DRAG_OVER,handleDragOver,false,0,true);
			imageBackground.addEventListener(NativeDragEvent.NATIVE_DRAG_EXIT,handleDragExit,false,0,true);
			imageBackground.addEventListener(NativeDragEvent.NATIVE_DRAG_DROP,handleDragDrop,false,0,true);
		}
		
		private function handleDragOver(evt:NativeDragEvent):void {
			var accept:Boolean = false;
			if (evt.clipboard.hasFormat(ClipboardFormats.FILE_LIST_FORMAT)) {
				var file:File = evt.clipboard.getData(ClipboardFormats.FILE_LIST_FORMAT)[0] as File;
				var fileExt:String = file.url.substr(file.url.lastIndexOf(".")+1);
				accept = (fileExt in imageFileExtensions);
			} else if (evt.clipboard.hasFormat(ClipboardFormats.BITMAP_FORMAT)) {
				accept = true;
			}
			if (accept) {
				DragManager.acceptDragDrop(imageBackground);
				dragHighlight.visible = true;
				dragHighlight.alpha = 1;
			}
		}
		
		private function handleDragExit(evt:NativeDragEvent):void {
			resetHighlight();
		}
				
		private function handleDragDrop(evt:NativeDragEvent):void {
			if (evt.clipboard.hasFormat(ClipboardFormats.FILE_LIST_FORMAT)) {
				var file:File = evt.clipboard.getData(ClipboardFormats.FILE_LIST_FORMAT)[0] as File;
				fileName = file.url.substr(file.url.lastIndexOf("/")+1);
				loader.load(new URLRequest(file.url));
			} else if (evt.clipboard.hasFormat(ClipboardFormats.BITMAP_FORMAT)) {
				fileName = "image.jpg";
				setBitmapData(evt.clipboard.getData(ClipboardFormats.BITMAP_FORMAT) as BitmapData);
			} else {
				resetHighlight();
			}
		}
		
		
		// save logic:
		private function handleSave(evt:MouseEvent):void {
			var file:File = new File();
			file.url = File.userDirectory.url + "/" +fileName;
			file.addEventListener(Event.SELECT,handleSaveSelect);
			file.browseForSave("Where would you like to save this image?");
		}
		
		private function handleSaveSelect(evt:Event):void {
			var bmpd:BitmapData = new BitmapData(bmp.width,bmp.height,false,0);
			bmpd.draw(bmp.bitmapData,new Matrix(bmp.scaleX,0,0,bmp.scaleY,0,0),null,null,null,true);
			var encoder:JPEGEncoder = new JPEGEncoder(Number(leftControls.qualityFld.text));
			var data:ByteArray = encoder.encode(bmpd);
			bmpd.dispose();
			// update file name:
			var fileStream:FileStream = new FileStream();
			fileStream.open((evt.target as File),FileMode.WRITE);
			fileStream.writeBytes(data);
			fileStream.close();
		}
	}
}